%def_without M24

%if_with M24
%define _release alt1.M24.1
%else
%define _release alt2
%endif

%if_with M24
%set_verify_elf_method textrel=relaxed
%endif

%define cvsdate 20050406
#%%undefine cvsdate
%def_disable mp3lame
%def_enable ogg
%def_enable vorbis
%def_disable a52
%def_enable a52bin
%def_disable faad
%def_enable faadbin
%def_disable faac
%def_enable xvid
%def_disable dts

Name: ffmpeg
Version: 0.4.9

%ifdef cvsdate
Release: %{_release}cvs%cvsdate
%else
Release: %_release
%endif

Summary: Hyper fast MPEG1/MPEG4/H263/RV and AC3/MPEG audio encoder
Summary(ru_RU.KOI8-R):  / MPEG1/MPEG4/H263/RV  AC3/MPEG
Group: Video
License: GPL
Url: http://%name.sourceforge.net

%ifndef cvsdate
Source: http://prdownloads.sourceforge.net/%name/%name-%version.tar.gz
%else
Source: http://mplayerhq.hu/MPlayer/cvs/FFMpeg-%cvsdate.tar.bz2
%endif

Patch0: ffmpeg-20041113-alt-include.patch
# Debian: patent issues
Patch1: ffmpeg-20050313-deb-legal.patch
# Debian: MMX and PARISC/S390 improvements
Patch3: ffmpeg-20050313-deb-arch.patch
# ALT: hide configure options banner
Patch4: ffmpeg-20050329-alt-nobanner.patch
# Debian: ffmpeg-config manpage
Patch5: ffmpeg-20050313-deb-config.patch
# Debian, ALT: ffmpeg-config for development packages
Patch6: ffmpeg-20050313-alt-config.patch

### ffmpeg CVS patches follow ###
# CABAC support for MBAFF I frames
#Patch10: ffmpeg-20050405-cvs-cabac.patch
# Fix colors for YV12 case in loco (u/v planes are swapped)
Patch11: ffmpeg-20050407-cvs-locoyv12.patch
# Fixing lossless snow
#Patch12: ffmpeg-20050405-cvs-snow.patch
# 10% faster unpack_coeffs
#Patch13: ffmpeg-20050405-cvs-unpack.patch


Requires: lib%name = %version-%release

%if_enabled a52bin
Requires: liba52
%endif

%if_enabled faadbin
Requires: libfaad
%endif

# Added on Thu Dec 23 2004
BuildRequires: esound freetype2-devel imlib2-devel libSDL-devel XFree86-devel zlib-devel tetex-core
# XFree86-libs

%if_enabled mp3lame
BuildRequires: liblame-devel
%endif

%if_enabled ogg
BuildRequires: libogg-devel
%endif

%if_enabled vorbis
BuildRequires: libvorbis-devel
%endif

%if_enabled a52
%if_disabled a52bin
BuildRequires: liba52-devel
%endif
%endif

%if_enabled faad
%if_disabled faadbin
BuildRequires: libfaad-devel
%endif
%endif

%if_enabled faac
BuildRequires: libfaac-devel
%endif

%if_enabled xvid
BuildRequires: xvid-devel
%endif

%description
%name is a hyper fast realtime audio/video encoder, a streaming
server and a generic audio and video file converter. 

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

%description -l ru_RU.KOI8-R
%name --  "" /   , 
    ,      
    .

%name      Video4Linux  
        
  DCT/motion.      
 MPEG audio layer 2  ,   AC3.

%package -n lib%name
Summary: Shared libraries to run ffmpeg
Group: System/Libraries
Provides: libavcodec.so
Provides: libavformat.so

%description -n lib%name
This package contains the shared libraries required for ffmpeg

%description -n lib%name -l ru_RU.KOI8-R
      ffmpeg.

%package devel
Summary: Development files for ffmpeg
Group: Development/C
Requires: lib%name = %version-%release

%description devel
This package includes the development libraries, header files and
documentation necessary for developing programs which will use ffmpeg.

%description -l ru_RU.KOI8-R devel
          
 ffmpeg --   ,    
.

%prep
%ifndef cvsdate
%setup -q -n %name-%version
%else
%setup -q -n FFMpeg-%cvsdate
%endif

%patch0 -p1
%patch1 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

# ffmpeg CVS patches
#%patch10 -p1
%patch11 -p1
#%patch12 -p1
#%patch13 -p1

find ./ -name Makefile -print0 |xargs -r0 %__subst '/ldconfig/d' --
%__subst 's,\-lImlib2,`imlib2-config --libs`,' configure

%build
export CFLAGS="-I../ -I%_includedir/mp4"
%configure \
    --enable-gpl \
    --enable-pp \
    --enable-shared-pp \
    --enable-pthreads \
    --enable-shared \
%ifnarch i686 athlon
    --disable-mmx \
%endif
    %{subst_enable mp3lame} \
    %{subst_enable ogg} \
    %{subst_enable vorbis} \
    %{subst_enable a52} \
    %{subst_enable a52bin} \
    %{subst_enable faad} \
    %{subst_enable faadbin} \
    %{subst_enable faac} \
    %{subst_enable xvid} \
    %{subst_enable dts}

# SMP-incompatible build
%make
%make_build -C doc
%make includedir=%_includedir ffmpeg-config

%install
%makeinstall

# libpostproc header
%__install -pD -m644 libavcodec/libpostproc/postprocess.h \
    %buildroot%_includedir/postproc/postprocess.h

# server config
%__install -pD -m640 doc/ffserver.conf %buildroot%_sysconfdir/ffserver.conf

%__install -m755 ffmpeg-config %buildroot%_bindir/ffmpeg-config
%__install -m644 ffmpeg-config.1 %buildroot%_man1dir/ffmpeg-config.1

%post -n lib%name -p %post_ldconfig
%postun -n lib%name -p %postun_ldconfig

%files
%exclude %_bindir/%name-config
%exclude %_man1dir/%name-config.*
%_bindir/*
%_man1dir/*
%config(noreplace) %_sysconfdir/*
%doc README doc/TODO Changelog doc/*.html doc/README.ALT doc/*.txt

%files -n lib%name
%_libdir/*.so*
%dir %_libdir/vhook
%_libdir/vhook/*.so

%files devel
%_includedir/*
%_bindir/%name-config
%_man1dir/%name-config.*

%changelog
* Wed Apr 13 2005 Grigory Batalov <bga@altlinux.ru> 0.4.9-alt2cvs20050406
- ffmpeg-config shows build time options (instead of predefined)
- libpostproc is built as shared library
- specfile cleanup

* Thu Apr 07 2005 Grigory Batalov <bga@altlinux.ru> 0.4.9-alt1cvs20050406
- new cvs snapshot for DVD VOBU sectors support
- legal issues, arch improvements and ffmpeg-config from Debian

* Wed Dec 22 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.4.9-alt0.5cvs20041113
- new cvs snapshot to build vlc-0.8.1

* Mon May 31 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.4.8-alt6cvs20040520
- new cvs snapshot to build vlc-0.7.2

* Thu Apr 15 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.4.8-alt5cvs20040222
- new cvs snapshot to build vlc-0.7.1

* Thu Jan 08 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.4.8-alt4cvs20040103
- install postprocess.h while MPlayer doesn't provides libposproc.
- fix build with faad.

* Mon Jan 05 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.4.8-alt3cvs20040103
- new cvs snapshot to build vlc-0.7.

* Fri Nov 21 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.4.8-alt2
- build with faad support.
- fixed imlib2 detection.
- fixed TEXTREL bug.

* Thu Oct 02 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.4.8-alt1
- 0.4.8

* Fri Jul 04 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.4.6-alt1cvs20030622
- cvs snapshot to build vlc-0.6.
- summary, descriptions by avp.

* Mon Mar 24 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.4.6-alt1cvs20030304
- cvs snapshot to build vlc.

* Sat Dec 28 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.4.6-alt1
- official release.

* Thu Dec 12 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.4.6-alt0.4cvs20021212
- current cvs snapshot.

* Fri Nov 01 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.4.6-alt0.3cvs20021101
- current cvs snapshot.

* Sun Jul 21 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.4.6-alt0.2cvs20020721
- current cvs snapshot (libname changed to libavcodec).
- ffserver.conf from documentation added in filelist as a config.

* Sat May 25 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.4.6-alt0.1cvs20020525
- First build for Sisyphus.
